//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * ÓI3DTEh
 * @author Junpee
 */

#include "LampBasic.h"
#include "Sound/3D/StaticSound3D.h"
#include "Sound/System/LampSound.h"
#include "Sound/System/SoundManager.h"

namespace Lamp{

//------------------------------------------------------------------------------
// RXgN^
StaticSound3D::StaticSound3D(DirectSoundBuffer* soundBuffer) :
	Sound3D(soundBuffer){
}
//------------------------------------------------------------------------------
// fXgN^
StaticSound3D::~StaticSound3D(){
}
//------------------------------------------------------------------------------
// 
Sound* StaticSound3D::clone(){
	StaticSound3D* destination =
		LampSound::getSoundManager()->cloneStaticSound3D(this);
	copySound3DData(destination);
	return destination;
}
//------------------------------------------------------------------------------
} // End of namespace Lamp
//------------------------------------------------------------------------------
